package com.yihu.hos.config;

import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.ImportResource;

/**
 * @author HZY
 * @vsrsion 1.0
 * Created at 2016/8/5.
 */
@Configuration
//@EnableTransactionManagement
//@ComponentScan("com.yihu.hos")
@ImportResource({"classpath:spring/applicationContext.xml"}) //applicationContext相关bean创建
public class BeanConfig{


//    private Environment environment;
//    private RelaxedPropertyResolver datasourcePropertyResolver;
//    private RelaxedPropertyResolver hibernatePropertyResolver;
//
//
//    //从application.yml中读取资源
//    @Override
//    public void setEnvironment(Environment environment) {
//        this.environment = environment;
//        this.datasourcePropertyResolver = new RelaxedPropertyResolver(environment, "spring.datasource.");
//        this.hibernatePropertyResolver = new RelaxedPropertyResolver(environment, "spring.jpa.");
//
//    }
//
//    //datasource 池方式
////    @Bean(initMethod = "init", destroyMethod = "close")
////    public DataSource dataSource() throws SQLException {
////        if (StringUtils.isEmpty(datasourcePropertyResolver.getProperty("url"))) {
////            System.out.println("Your database connection pool configuration is incorrect!" +
////                    " Please check your Spring profile, current profiles are:"+
////                    Arrays.toString(environment.getActiveProfiles()));
////            throw new ApplicationContextException(
////                    "Database connection pool is not configured correctly");
////        }
////        DruidDataSource druidDataSource = new DruidDataSource();
////        druidDataSource.setUrl(datasourcePropertyResolver.getProperty("url"));
////        druidDataSource.setUsername(datasourcePropertyResolver
////                .getProperty("username"));
////        druidDataSource.setPassword(datasourcePropertyResolver
////                .getProperty("password"));
////        druidDataSource.setInitialSize(1);
////        druidDataSource.setMinIdle(1);
////        druidDataSource.setMaxActive(20);
////        druidDataSource.setMaxWait(60000);
////        druidDataSource.setTimeBetweenEvictionRunsMillis(60000);
////        druidDataSource.setMinEvictableIdleTimeMillis(300000);
////        druidDataSource.setValidationQuery("SELECT　'x'");
////        druidDataSource.setTestWhileIdle(true);
////        druidDataSource.setTestOnBorrow(false);
////        druidDataSource.setTestOnReturn(false);
////        return druidDataSource;
////    }
//
//    @Bean( destroyMethod = "close")
//    public BasicDataSource dataSource() throws SQLException {
//        if (StringUtils.isEmpty(datasourcePropertyResolver.getProperty("url"))) {
//            System.out.println("Your database connection pool configuration is incorrect!" +
//                    " Please check your Spring profile, current profiles are:"+
//                    Arrays.toString(environment.getActiveProfiles()));
//            throw new ApplicationContextException(
//                    "Database connection pool is not configured correctly");
//        }
//        BasicDataSource dataSource = new BasicDataSource();
//        dataSource.setUrl(datasourcePropertyResolver.getProperty("url"));
//        dataSource.setUsername(datasourcePropertyResolver.getProperty("username"));
//        dataSource.setPassword(datasourcePropertyResolver.getProperty("password"));
//        dataSource.setInitialSize(datasourcePropertyResolver.getProperty("initial-size", Integer.class));
//        dataSource.setMaxTotal(datasourcePropertyResolver.getProperty("max-total", Integer.class));
//        dataSource.setMinIdle(datasourcePropertyResolver.getProperty("min-idle",Integer.class));
//        dataSource.setMaxIdle(datasourcePropertyResolver.getProperty("max-idle",Integer.class));
//        dataSource.setValidationQuery(datasourcePropertyResolver.getProperty("validation-query"));
//        dataSource.setRemoveAbandonedTimeout(55);
//        dataSource.setTestOnBorrow(datasourcePropertyResolver.getProperty("test-on-borrow",Boolean.class));
//        return dataSource;
//    }
//
//    //sessionFactory
//    @Bean
//    public LocalSessionFactoryBean sessionFactory() throws SQLException {
//        LocalSessionFactoryBean localSessionFactoryBean = new LocalSessionFactoryBean();
//        localSessionFactoryBean.setDataSource(this.dataSource());
//        Properties properties1 = new Properties();
//        properties1.setProperty("hibernate.dialect",hibernatePropertyResolver.getProperty("hibernate.dialect"));
//        properties1.setProperty("hibernate.show_sql",hibernatePropertyResolver.getProperty("show-sql"));
//        properties1.setProperty("hibernate.format_sql",hibernatePropertyResolver.getProperty("format-sql"));
//        localSessionFactoryBean.setHibernateProperties(properties1);
//        localSessionFactoryBean.setPackagesToScan("com.yihu.hos.standard.model");
//        ResourceLoader resourceLoader = new DefaultResourceLoader();
//        Resource resource = resourceLoader.getResource("classpath:resource/");
//        localSessionFactoryBean.setMappingDirectoryLocations(resource);
////        localSessionFactoryBean.setPackagesToScan("*");
//        return localSessionFactoryBean;
//    }
//
//    //txManager事务开启
//    @Bean
//    public HibernateTransactionManager txManager() throws SQLException {
//        HibernateTransactionManager hibernateTransactionManager = new HibernateTransactionManager();
//        hibernateTransactionManager.setSessionFactory(sessionFactory().getObject());
//        return hibernateTransactionManager;
//    }
//
//    //文经上传
//    @Bean
//    public CommonsMultipartResolver multipartResolver(){
//        return new CommonsMultipartResolver();
//    }
//
//    //国际化配置
//    @Bean
//    public ResourceBundleMessageSource messageSource(){
//        ResourceBundleMessageSource messageSource =new ResourceBundleMessageSource();
//        messageSource.setBasenames("text/message");
//        messageSource.setDefaultEncoding("UTF-8");
//        return messageSource;
//    }
//
//    @Bean
//    public CookieLocaleResolver localeResolver(){
//        CookieLocaleResolver localeResolver = new CookieLocaleResolver();
//        localeResolver.setCookieName("Language");
//        localeResolver.setCookieMaxAge(604800);
//        localeResolver.setDefaultLocale(new Locale("zh_CN"));
//        return localeResolver;
//    }
//
//    @Bean
//    public LocaleChangeInterceptor localeChangeInterceptor(){
//        return new LocaleChangeInterceptor();
//    }
//
//    @Bean
//    public JdbcTemplate jdbcTemplate(){
//        JdbcTemplate jdbcTemplate = new JdbcTemplate();
//        try {
//            jdbcTemplate.setDataSource(this.dataSource());
//        } catch (SQLException e) {
//            e.printStackTrace();
//        }
//        return jdbcTemplate;
//    }
//
//    //Hibernate模版配置
//    @Bean
//    public HibernateTemplate hibernateTemplate() throws SQLException {
//        HibernateTemplate hibernateTemplate = new HibernateTemplate();
//        hibernateTemplate.setSessionFactory(this.sessionFactory().getObject());
//        return hibernateTemplate;
//    }
}
